petsc-3.7.1 2016-05-15
Report Typos and Errors

# PCBDDC

Balancing Domain Decomposition by Constraints. An implementation of the BDDC preconditioner based on Many br

       [1] C. R. Dohrmann. "An approximate BDDC preconditioner", Numerical Linear Algebra with Applications Volume 14, Issue 2, pages 149-168, March 2007
       [2] A. Klawonn and O. B. Widlund. "Dual-Primal FETI Methods for Linear Elasticity", http://cs.nyu.edu/csweb/Research/TechReports/TR2004-855/TR2004-855.pdf
       [3] J. Mandel, B. Sousedik, C. R. Dohrmann. "Multispace and Multilevel BDDC", http://arxiv.org/abs/0712.3977
       [4] C. Pechstein and C. R. Dohrmann. "Modern domain decomposition methods BDDC, deluxe scaling, and an algebraic approach", Seminar talk, Linz, December 2013, http://people.ricam.oeaw.ac.at/c.pechstein/pechstein-bddc2013.pdf

Many br

The matrix to be preconditioned (Pmat) must be of type MATIS. Many br

Currently works with MATIS matrices with local matrices of type MATSEQAIJ, MATSEQBAIJ or MATSEQSBAIJ, either with real or complex numbers. Many br

It also works with unsymmetric and indefinite problems. Many br

Unlike 'conventional' interface preconditioners, PCBDDC iterates over all degrees of freedom, not just those on the interface. This allows the use of approximate solvers on the subdomains. Many br

Approximate local solvers are automatically adapted for singular linear problems (see [1]) if the user has provided the nullspace using PCBDDCSetNullSpace() Many br

Boundary nodes are split in vertices, edges and faces classes using information from the local to global mapping of dofs and the local connectivity graph of nodes. The latter can be customized by using PCBDDCSetLocalAdjacencyGraph() Many brAdditional information on dofs can be provided by using PCBDDCSetDofsSplitting(), PCBDDCSetDirichletBoundaries(), PCBDDCSetNeumannBoundaries(), and PCBDDCSetPrimalVerticesLocalIS() Many br

Constraints can be customized by attaching a MatNullSpace object to the MATIS matrix via MatSetNearNullSpace(). Non-singular modes are retained via SVD. Many br

Change of basis is performed similarly to [2] when requested. When more than one constraint is present on a single connected component (i.e. an edge or a face), a robust method based on local QR factorizations is used. Many brUser defined change of basis can be passed to PCBDDC by using PCBDDCSetChangeOfBasisMat() Many br

The PETSc implementation also supports multilevel BDDC [3]. Coarse grids are partitioned using a MatPartitioning object. Many br

Adaptive selection of primal constraints [4] is supported for SPD systems with high-contrast in the coefficients if MUMPS is present. Future versions of the code will also consider using MKL_PARDISO or PASTIX. Many br

An experimental interface to the FETI-DP method is available. FETI-DP operators could be created using PCBDDCCreateFETIDPOperators(). A stand-alone class for the FETI-DP method will be provided in the next releases. Many brDeluxe scaling is not supported yet for FETI-DP. Many br

### Options Database Keys (some of them, run with -h for a complete list)

-pc_bddc_use_vertices <true> -use or not vertices in primal space Many br
-pc_bddc_use_edges <true> -use or not edges in primal space Many br
-pc_bddc_use_faces <false> -use or not faces in primal space Many br
-pc_bddc_symmetric <true> -symmetric computation of primal basis functions. Specify false for unsymmetric problems Many br
-pc_bddc_use_change_of_basis <false> -use change of basis approach (on edges only) Many br
-pc_bddc_use_change_on_faces <false> -use change of basis approach on faces if change of basis has been requested Many br
-pc_bddc_switch_static <false> -switches from M_2 (default) to M_3 operator (see reference article [1]) Many br
-pc_bddc_levels <0> -maximum number of levels for multilevel Many br
-pc_bddc_coarsening_ratio <8> -number of subdomains which will be aggregated together at the coarser level (e.g. H/h ratio at the coarser level, significative only in the multilevel case) Many br
-pc_bddc_redistribute <0> -size of a subset of processors where the coarse problem will be remapped (the value is ignored if not at the coarsest level) Many br
-pc_bddc_use_deluxe_scaling <false> -use deluxe scaling Many br
-pc_bddc_schur_layers < -1> - select the economic version of deluxe scaling by specifying the number of layers (-1 corresponds to the original deluxe scaling) Many br
-pc_bddc_adaptive_threshold <0.0> -when a value greater than one is specified, adaptive selection of constraints is performed on edges and faces (requires deluxe scaling and MUMPS installed) Many br
-pc_bddc_check_level <0> -set verbosity level of debugging output Many br

Options for Dirichlet, Neumann or coarse solver can be set with Many br

          -pc_bddc_dirichlet_
          -pc_bddc_neumann_
          -pc_bddc_coarse_

Many bre.g -pc_bddc_dirichlet_ksp_type richardson -pc_bddc_dirichlet_pc_type gamg. PCBDDC uses by default KPSPREONLY and PCLU. Many br

When using a multilevel approach, solvers' options at the N-th level (N > 1) can be specified as Many br

          -pc_bddc_dirichlet_lN_
          -pc_bddc_neumann_lN_
          -pc_bddc_coarse_lN_

Many brNote that level number ranges from the finest (0) to the coarsest (N). Many brIn order to specify options for the BDDC operators at the coarser levels (and not for the solvers), prepend -pc_bddc_coarse_ or -pc_bddc_coarse_l to the option, e.g. Many br

         -pc_bddc_coarse_pc_bddc_adaptive_threshold 5 -pc_bddc_coarse_l1_pc_bddc_redistribute 3

Many brwill use a threshold of 5 for constraints' selection at the first coarse level and will redistribute the coarse problem of the first coarse level on 3 processors Many br

Many br

### Developer notes

Contributed by Stefano Zampini Many br

### See Also

PCCreate(), PCSetType(), PCType (for list of available types), PC, MATIS

Level:intermediate
Location:src/ksp/pc/impls/bddc/bddc.c
Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages